// WinampRemort.h

#pragma once

using namespace System;

#include "Winamp.h"

namespace WinampCLI
{
	/// <summary>
	/// ^f[^tB[h񋓎q
	/// </summary>
	private enum class MetaField
	{
		/// <summary>
		/// A[eBXg
		/// </summary>
		Artist = METAFIELD_ARTIST,
		/// <summary>
		/// Ao
		/// </summary>
		Album = METAFIELD_ALBUM,
		/// <summary>
		/// gbN
		/// </summary>
		TrackName = METAFIELD_TRACKNAME,
		/// <summary>
		/// gbNԍ
		/// </summary>
		TrackNumber = METAFIELD_TRACKNUMBER,
	};

	/// <summary>
	/// SendCommandMessase Ŏgp R}h萔
	/// </summary>
	private enum CtrlCommand
	{
		/// <summary>
		/// ŐȂփXLbv
		/// </summary>
		Prev = CTRLWINAMP_COMMAND_SKIP_BEFORE,
		/// <summary>
		/// Đ
		/// </summary>
		Play = CTRLWINAMP_COMMAND_PLAY,
		/// <summary>
		/// ꎞ~
		/// </summary>
		Pause = CTRLWINAMP_COMMAND_PAUSE,
		/// <summary>
		/// ~
		/// </summary>
		Stop = CTRLWINAMP_COMMAND_STOP,
		/// <summary>
		/// ̋ȂփXLbv
		/// </summary>
		Next = CTRLWINAMP_COMMAND_SKIP_NEXT,
	};

	/// <summary>
	/// Winamp NX (C++/CLI)
	/// </summary>
	private ref class WinampCLI
	{
	public:
		/// <summary>
		/// Winamp ƐڑĂ邩𒲂ׂ܂
		/// </summary>
		static property bool IsConnected
		{
			bool get() { return Winamp::FindWinamp() != NULL; }
		}

		/// <summary>
		/// Đ𒲂ׂ܂
		/// </summary>
		static property bool IsPlaying
		{
			bool get() { return Winamp::IsPlaying(); }
		}

		/// <summary>
		/// ʂݒA擾i0`100j
		/// </summary>
		static property int SoundVolume
		{
			int get() { return Winamp::GetSoundVolume(); }
			void set(int value) { Winamp::SetSoundVolume(value); }
		}

		/// <summary>
		/// Đʒu[s]ŐݒA擾
		/// </summary>
		static property int PlayerPosition
		{
			int get() { return Winamp::GetPlayerPosition(); }
			void set(int value) { Winamp::SetPlayerPosition(value); }
		}
		
		/// <summary>
		/// Đ̋Ȃ̑tԂ[s]Ŏ擾
		/// </summary>
		static property int PlayingTrackLength
		{
			int get() { return Winamp::GetPlayingTrackLength(); }
		}

		/// <summary>
		/// ݑIĂvCXg̃CfbNX擾
		/// </summary>
		static property int PlayListPosition
		{
			int get() { return Winamp::GetPlayListPosition(); }
		}

		/// <summary>
		/// ĐRg[
		/// </summary>
		static bool SendCommandMessase(CtrlCommand cmd);
		/// <summary>
		/// vCXg̃CfbNXw肵āA̋Ȃ̃t@CpX擾
		/// </summary>
		static bool GetPlayListFilename(int index, [Runtime::InteropServices::Out]String^ %filepath);
		/// <summary>
		/// ^f[^擾܂
		/// </summary>
		static bool GetMetaDataInfo(String^ filepath, MetaField field, [Runtime::InteropServices::Out]String^ %metadata);
	};
}
