﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Windows.Forms.Design;

using System.Drawing;

namespace NauPlaying
{
	class EditorBoardLocate : System.Drawing.Design.UITypeEditor
	{
		private FormPositioner _form = null;

		public EditorBoardLocate()
		{			
		}

		// 編集スタイルの取得
		public override System.Drawing.Design.UITypeEditorEditStyle GetEditStyle(System.ComponentModel.ITypeDescriptorContext context)
		{
			return System.Drawing.Design.UITypeEditorEditStyle.Modal;
		}

		// 値の編集
		public override object EditValue(System.ComponentModel.ITypeDescriptorContext context, IServiceProvider provider, object value)
		{
			IWindowsFormsEditorService editservice = (IWindowsFormsEditorService)provider.GetService(typeof(IWindowsFormsEditorService));

			if(_form == null)
			{
				_form = new FormPositioner();
			}

			_form.Location = (Point)value;

			if(_form.ShowDialog() == DialogResult.OK)
				return _form.Location;
			else
				return value;
		}
	}
}
