﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace NauPlaying.Skin
{
	/// <summary>
	/// スキン情報クラス
	/// </summary>
	public class SkinInfo
	{
		/// <summary>
		/// スキンファイルのフルパス
		/// </summary>
		public string Fullpath { set; get; }
		/// <summary>
		/// スキン設定
		/// </summary>
		public SkinSetting SkinSetting { set; get; }

		/// <summary>
		/// 標準のコンストラクタ
		/// </summary>
		/// <param name="fullpath">スキンファイルのフルパス</param>
		/// <param name="skinSetting">スキン設定</param>
		public SkinInfo(string fullpath, SkinSetting skinSetting)
		{
			Fullpath = fullpath;
			SkinSetting = skinSetting;
		}
	}
}
