﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace PluginBase
{
	/// <summary>
	/// シングルトン化のためのヘルパークラスのインターフェース
	/// </summary>
	public interface ISingletonHelper
	{
		/// <summary>
		/// シングルトンオブジェクトのインスタンスを取得
		/// </summary>
		IPlugin Instance { get; }
	}
}
